function [s, lambdamax, umax] = compute_sigma_fdiv_lambdamax(M,N,V,n_init)


d =  size(M,1);

% starts with a uniform grid on [0,1]
ss_grid = ( 0:(n_init-1) )  / ( n_init - 1);
for igrid = 1:length(ss_grid)
    rr = ss_grid(igrid) / ( 1-ss_grid(igrid));
    if rr==0
        perfs(igrid) = max(real(eig(N -  V )));
    elseif rr==Inf
        perfs(igrid) = -Inf;
    else
        perfs(igrid) = max(real(eig(rr*M+N - ( rr*log(rr) - rr + 1)* V ))) / (rr+1);
    end
end


% find best perf
[a,igrid] = max(perfs);
ss = ss_grid(igrid);
rr = ss/(1-ss);

% launch iterative improvement algorithm
try
    maxiter = 40;
    for iter = 1:maxiter
        % compute s
        if rr==0
            [uu,ee] = eig(N -  V );
            
        else
            
             [uu,ee] = eig(rr*M+N - ( rr*log(rr) - rr + 1)* V );
        end
        [a,b] = max(real(diag(ee)));
        umax = uu(:,b);
        
        
        % update r
        u = trace(umax'*M*umax)-trace(umax'*N*umax);
        u = u / ( umax' * V * umax);
         if u>0
            rr = 1;
            for jj=1:6  % 6 iterations enough
                rr = (2 - log(rr) + u )./ ( 1 + 1./rr);
            end
        else
            rr = 1;
            for jj=1:6   % 6 iterations enough
                rr  =exp( ( 1+u + rr .* ( log(rr)-1))./(1+rr) );
            end
        end
        ss = rr / (rr+1);
        
    end
catch
    ss = ss_grid(igrid);
    
end
s = ss;
rr = ss/(1-ss);
if rr==0
    [uu,ee] = eig(N -  V );
else
    [uu,ee] = eig(rr*M+N - ( rr*log(rr) - rr + 1)* V );
end
[a,b] = max(real(diag(ee)));
umax = uu(:,b);
lambdamax = a / ( rr + 1);
