function [Z,Y,gap,niter] = maximize_sos_chambolle_pock(A,epsilongap,maxiter,Y,Sigma)
m = size(A,1);


global TP % load the projection matrix

if nargin<4
    Y = zeros(m);
    Sigma = eye(m)/m;
end
Ybar = Y;
sigma = 1/2;
tau = 2;

niter = maxiter;
for iter = 1:maxiter
    
    [u,e] = eig( Sigma + sigma * ( A + Ybar) ); u = real(u); e = real(e);
    
    es = simplex_projection( diag(e) );
    Sigma = u * diag(es) * u';
    Yp = Y - tau * Sigma;
    Yp = Yp - reshape(TP*Yp(:),[m m]);
    Ybar = 2 * Yp - Y;
    Y = Yp;
    
    if mod(iter,5)==1
        Z = Sigma;
        % Z = toeplitz_projection(Z);
        Z = reshape(TP*Z(:),[m m]);
        f=min(real(eig(Z)));
        if f<0, Z = Z - eye(m)*f; end
        Z = Z / trace(Z);
        gap = max(real(eig(A+Y)))-trace(Z*A);
        if gap < epsilongap, niter = iter; return; end
    end
end
Z = Sigma;
% Z = toeplitz_projection(Z);
Z = reshape(TP*Z(:),[m m]);
f=min(real(eig(Z)));
if f<0, Z = Z - eye(m)*f; end
Z = Z / trace(Z);
gap = max(real(eig(A+Y)))-trace(Z*A);


